; MASMCAM webcam viewer by Mark Jones 2006
; Ported from FASMCAM by Marcus Araujo.
; Note you may need to install the avicap.inc and .lib

include masm32rt.inc    ; standard masm32v9+ compile-time libs
uselib avicap32         ; loads avicap32.inc and avicap32.lib
;uselib vfw32            ; vfw libs, not present on XP!

    DlgProc             PROTO :HWND,:UINT,:WPARAM,:LPARAM

.const
    IDD_MAIN                    equ 100     ; dialog items
    ID_START                    equ 101
    ID_STOP                     equ 102
    ID_SAVE                     equ 103
;    WM_CAP_DRIVER_CONNECT       equ WM_USER + 10
;    WM_CAP_DRIVER_DISCONNECT    equ WM_USER + 11
    WM_CAP_FILE_SAVEDIB         equ WM_USER + 25
;    WM_CAP_SET_PREVIEW          equ WM_USER + 50
;    WM_CAP_SET_PREVIEWRATE      equ WM_USER + 52
;    WM_CAP_SET_SCALE            equ WM_USER + 53

.data?
    hInstance           dd ?
    hWebcam             dd ?

.data
    nDevice             dd 0                ; device number -> 0 through 9
    nFPS                dd 100              ; frames/sec. must be 1000/FPS.
    _camtitle           db 'MASM-CAM',0     ; e.g. 20 FPS = dd 50
    _filename           db 'image.bmp',0    ; output filename

.code
start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke ExitProcess,0


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov eax,uMsg
	.if eax==WM_INITDIALOG
      invoke capCreateCaptureWindow,addr _camtitle,WS_VISIBLE + WS_CHILD,\
                                                    0,0,320,240,hWin,0
      mov hWebcam,eax

	.elseif eax==WM_COMMAND
        mov eax,wParam
        shl eax,16
        .if eax==ID_START
            invoke SendMessage,hWebcam,WM_CAP_DRIVER_CONNECT,nDevice,0
            invoke SendMessage,hWebcam,WM_CAP_SET_SCALE,TRUE,0
            invoke SendMessage,hWebcam,WM_CAP_SET_PREVIEWRATE,nFPS,0
            invoke SendMessage,hWebcam,WM_CAP_SET_PREVIEW,TRUE,0
        .elseif eax==ID_STOP
            invoke SendMessage,hWebcam,WM_CAP_DRIVER_DISCONNECT,addr _camtitle,0
        .elseif eax==ID_SAVE
            invoke SendMessage,hWebcam,WM_CAP_FILE_SAVEDIB,0,addr _filename
        .endif
        
	.elseif eax==WM_CLOSE
        invoke SendMessage,hWebcam,WM_CAP_DRIVER_DISCONNECT,addr _camtitle,0
        invoke EndDialog,hWin,0
    .else
        mov	eax,FALSE
        ret
    .endif
    mov	eax,TRUE
    ret
DlgProc endp


end start
